<ng-container *ngIf="{
        ghostElements: ghostElements$ | async,
        screenSize: screenSize$ | async,
        fmiPage: dataPage$ | async,
        categories: categories$ | async,
        competitions: competitions$ | async,
        divisions: divisions$ | async,
        groups: groups$ | async,
        days: days$ | async,
        weeks: weeks$ | async } as vm">
  <app-page-form>
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'admin.fmi.list.seo.title' | translate }}
      </h1>
      <p>
        {{ 'admin.fmi.list.seo.description' | translate }}
      </p>

      <form [formGroup]="formGroup">
        <mat-form-field>
          <mat-label>
            {{ 'admin.fmi.list.filter.category' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().category"
                                 (resetClick)="categoryChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.category"
                            [control]="formGroup.controls.category">
            <mat-select formControlName="category" (selectionChange)="categoryChange($event?.value)">
              <mat-option *ngFor="let category of vm.categories?.items; trackBy: trackBySlug"
                          [value]="category.slug">
                {{ category.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.fmi.list.filter.competition' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().competition"
                                 (resetClick)="competitionChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.competition"
                            [control]="formGroup.controls.competition">
            <mat-select formControlName="competition" (selectionChange)="competitionChange($event?.value)">
              <mat-option *ngFor="let competition of vm.competitions?.items; trackBy: trackBySlug"
                          [value]="competition.slug">
                {{ competition.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.fmi.list.filter.division' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().division"
                                 (resetClick)="divisionChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.division"
                            [control]="formGroup.controls.division">
            <mat-select formControlName="division" (selectionChange)="divisionChange($event?.value)">
              <mat-option *ngFor="let division of vm.divisions?.items; trackBy: trackBySlug"
                          [value]="division.slug">
                {{ division.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.fmi.list.filter.group' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().group"
                                 (resetClick)="groupChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.group"
                            [control]="formGroup.controls.group">
            <mat-select formControlName="group" (selectionChange)="groupChange($event?.value)">
              <mat-option *ngFor="let group of vm.groups?.items; trackBy: trackBySlug"
                          [value]="group.slug">
                {{ group.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.fmi.list.filter.day' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().day"
                                 (resetClick)="dayChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.day"
                            [control]="formGroup.controls.day">
            <mat-select formControlName="day" (selectionChange)="dayChange($event?.value)">
              <mat-option *ngFor="let day of vm.days?.items; trackBy: trackBySlug"
                          [value]="day.slug">
                {{ day.index }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <span class="spacer" *ngIf="vm.screenSize === SCREEN_SIZES['md']"></span>
        <mat-form-field>
          <mat-label>
            {{ 'admin.fmi.list.filter.period.week.label' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().week"
                                 (resetClick)="weekChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.week"
                            [control]="formGroup.controls.week">
            <mat-select formControlName="week" (selectionChange)="weekChange($event?.value)"
                        [compareWith]="compareByWeek">
              <mat-option *ngFor="let week of vm.weeks; trackBy: trackBySlug"
                          [value]="week">
                {{ 'admin.fmi.list.filter.period.week.value' | translate:{ week: week.week, start: week.start.format('DD/MM/YYYY'), end: week.end.format('DD/MM/YYYY') } }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.fmi.list.filter.period.start' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().startDate"
                                 (resetClick)="formGroup.controls.startDate.patchValue(undefined)">
          </app-reset-button-icon>
          <mat-datepicker-toggle [for]="startDatePicker" matSuffix></mat-datepicker-toggle>
          <mat-datepicker #startDatePicker [startAt]="formGroup.value.startDate || formGroup.value.endDate"></mat-datepicker>
          <input matInput formControlName="startDate"
                 [matDatepicker]="startDatePicker" autocomplete="false">
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'admin.fmi.list.filter.period.end' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().endDate"
                                 (resetClick)="formGroup.controls.endDate.patchValue(undefined)">
          </app-reset-button-icon>
          <mat-datepicker-toggle [for]="endDatePicker" matSuffix></mat-datepicker-toggle>
          <mat-datepicker #endDatePicker [startAt]="formGroup.value.endDate || formGroup.value.startDate"></mat-datepicker>
          <input matInput formControlName="endDate"
                 [matDatepicker]="endDatePicker" autocomplete="false">
        </mat-form-field>
      </form>

      <section>
        <div class="table-wrapper">
          <table mat-table [dataSource]="loading.list ? vm.ghostElements : vm.fmiPage?.items"
                 [trackBy]="trackBySlug"
                 matSort matSortDisableClear
                 (matSortChange)="sort($event)"
                 [matSortActive]="vm.fmiPage?.sort?.field || 'date'"
                 [matSortDirection]="vm.fmiPage?.sort?.direction || 'asc'">

            <ng-container matColumnDef="date">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.fmi.list.field.date' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.date | date:'short':undefined:'fr-FR' }}
              </td>
            </ng-container>

            <ng-container matColumnDef="location">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.fmi.list.field.location' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.location }}
              </td>
            </ng-container>

            <ng-container matColumnDef="matchStatus">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.fmi.list.field.matchStatus.label' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                <mat-icon *ngIf="element.matchStatus"
                          [ngClass]="element.matchStatus"
                          [matTooltip]="'admin.fmi.list.field.matchStatus.value' | translate:{ status: 'admin.fmi.matchStatus.' + element.matchStatus | translate, matchCount: element.matchCount, requiredMatchCount: element.requiredMatchCount, teamCount: element?.teams?.length }">
                  <ng-container [ngSwitch]="element.matchStatus">
                    <ng-container *ngSwitchCase="FmiMatchStatus.COMPLETE">check_circle</ng-container>
                    <ng-container *ngSwitchCase="FmiMatchStatus.PARTIAL">warning</ng-container>
                    <ng-container *ngSwitchCase="FmiMatchStatus.EMPTY">error</ng-container>
                  </ng-container>
                </mat-icon>
              </td>
            </ng-container>

            <ng-container matColumnDef="matchCount">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.fmi.list.field.matchCount' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.matchCount }}
              </td>
            </ng-container>

            <ng-container matColumnDef="categoryName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.fmi.list.field.category' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.categoryName }}
              </td>
            </ng-container>

            <ng-container matColumnDef="competitionName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.fmi.list.field.competition' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.competitionName }}
              </td>
            </ng-container>

            <ng-container matColumnDef="divisionName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.fmi.list.field.division' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.divisionName }}
              </td>
            </ng-container>

            <ng-container matColumnDef="groupName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.fmi.list.field.group' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.groupName }}
              </td>
            </ng-container>

            <ng-container matColumnDef="dayIndex">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.fmi.list.field.day' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.dayIndex }}
              </td>
            </ng-container>

            <ng-container matColumnDef="teams">
              <th mat-header-cell *matHeaderCellDef
                  class="logo">
                {{ 'admin.fmi.list.field.teams' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                <div class="teams">
                  <figure *ngFor="let team of element.teams; trackBy: trackBySlug"
                          [matBadge]="'' + team.index">
                    <img class="lazy-load"
                         *ngIf="'common.team.defaultPicture.url' | translate"
                         [lazyLoad]="team.logoUrl || ('common.team.defaultPicture.url' | translate)"
                         [errorImage]="'common.team.defaultPicture.url' | translate"
                         [alt]="team.name"
                         [matTooltip]="team.name + ' ' + team.index" />
                  </figure>
                </div>
              </td>
            </ng-container>

            <ng-container matColumnDef="participant">
              <th mat-header-cell *matHeaderCellDef
                  class="logo">
                {{ 'admin.fmi.list.field.participant' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                <figure>
                  <img class="lazy-load"
                       *ngIf="'common.team.defaultPicture.url' | translate"
                       [lazyLoad]="element.participant?.logoUrl || ('common.team.defaultPicture.url' | translate)"
                       [errorImage]="'common.team.defaultPicture.url' | translate"
                       [alt]="element.participant?.name"
                       [matTooltip]="element.participant?.name" />
                </figure>
              </td>
            </ng-container>

            <ng-container matColumnDef="action">
              <th mat-header-cell *matHeaderCellDef></th>
              <td mat-cell *matCellDef="let element"
                  class="actions">
                <a mat-icon-button
                   [routerLink]="[element.slug, 'update']"
                   [attr.aria-label]="'admin.common.action.update' | translate"
                   [matTooltip]="'admin.common.action.update' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    edit
                  </mat-icon>
                </a>
                <a mat-icon-button
                   [routerLink]="[element.slug, 'duplicate']"
                   [attr.aria-label]="'admin.common.action.duplicate' | translate"
                   [matTooltip]="'admin.common.action.duplicate' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    filter_none
                  </mat-icon>
                </a>
                <button mat-icon-button
                        (click)="delete(element)"
                        [attr.aria-label]="'admin.common.action.delete' | translate"
                        [matTooltip]="'admin.common.action.delete' | translate"
                        matTooltipPosition="left">
                  <mat-icon>
                    delete
                  </mat-icon>
                </button>
              </td>
            </ng-container>

            <ng-container *ngFor="let ghostColumn of ghostColumns">
              <ng-container [matColumnDef]="ghostColumn">
                <td mat-cell *matCellDef class="ghost"><div></div></td>
              </ng-container>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="columns; sticky: true"></tr>
            <ng-container *ngIf="loading.list then ghost; else data"></ng-container>
            <ng-template #data>
              <tr mat-row *matRowDef="let row; columns: columns;"></tr>
            </ng-template>
            <ng-template #ghost>
              <tr mat-row *matRowDef="let row; columns: ghostColumns;"></tr>
            </ng-template>
          </table>
        </div>
        <mat-paginator [length]="vm.fmiPage?.count"
                       [pageIndex]="vm.fmiPage?.page"
                       [pageSize]="vm.fmiPage?.size"
                       [pageSizeOptions]="pageSizes"
                       (page)="goToPage($event)">
        </mat-paginator>
      </section>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-flat-button color="primary"
         [routerLink]="['create']"
         [queryParams]="{ category: formGroup.value.category, competition: formGroup.value.competition, division: formGroup.value.division, group: formGroup.value.group, day: formGroup.value.day }">
        <mat-icon>
          add
        </mat-icon>
        {{ 'admin.common.action.create' | translate }}
      </a>
    </ng-container>
  </app-page-form>
</ng-container>
